import 'dart:async';
import 'dart:developer';
import 'dart:io';

import 'package:easy_localization/easy_localization.dart';
import 'package:flutter/material.dart';
import 'package:hmg_patient_app_new/core/app_assets.dart';
import 'package:hmg_patient_app_new/core/app_state.dart';
import 'package:hmg_patient_app_new/core/cache_consts.dart';
import 'package:hmg_patient_app_new/core/dependencies.dart';
import 'package:hmg_patient_app_new/core/enums.dart';
import 'package:hmg_patient_app_new/core/utils/date_util.dart';
import 'package:hmg_patient_app_new/core/utils/size_utils.dart';
import 'package:hmg_patient_app_new/core/utils/utils.dart';
import 'package:hmg_patient_app_new/extensions/string_extensions.dart';
import 'package:hmg_patient_app_new/extensions/widget_extensions.dart';
import 'package:hmg_patient_app_new/features/book_appointments/book_appointments_view_model.dart';
import 'package:hmg_patient_app_new/features/my_appointments/models/resp_models/patient_appointment_history_response_model.dart';
import 'package:hmg_patient_app_new/features/my_appointments/my_appointments_view_model.dart';
import 'package:hmg_patient_app_new/features/payfort/models/apple_pay_request_insert_model.dart';
import 'package:hmg_patient_app_new/features/payfort/payfort_view_model.dart';
import 'package:hmg_patient_app_new/features/paytabs/models/paytabs_transaction_response_model.dart';
import 'package:hmg_patient_app_new/features/paytabs/paytabs_view_model.dart';
import 'package:hmg_patient_app_new/generated/locale_keys.g.dart';
import 'package:hmg_patient_app_new/presentation/home/navigation_screen.dart';
import 'package:hmg_patient_app_new/presentation/insurance/insurance_home_page.dart';
import 'package:hmg_patient_app_new/theme/colors.dart';
import 'package:hmg_patient_app_new/widgets/appbar/collapsing_list_view.dart';
import 'package:hmg_patient_app_new/widgets/buttons/custom_button.dart';
import 'package:hmg_patient_app_new/widgets/common_bottom_sheet.dart';
import 'package:hmg_patient_app_new/widgets/in_app_browser/InAppBrowser.dart';
import 'package:hmg_patient_app_new/widgets/loader/bottomsheet_loader.dart';
import 'package:hmg_patient_app_new/widgets/routes/custom_page_route.dart';
import 'package:provider/provider.dart';
import 'package:smooth_corner/smooth_corner.dart';

class WaitingAppointmentPaymentPage extends StatefulWidget {
  WaitingAppointmentPaymentPage({super.key});

  // PatientAppointmentHistoryResponseModel patientAppointmentHistoryResponseModel;

  @override
  State<WaitingAppointmentPaymentPage> createState() => _WaitingAppointmentPaymentPageState();
}

class _WaitingAppointmentPaymentPageState extends State<WaitingAppointmentPaymentPage> {
  late BookAppointmentsViewModel bookAppointmentsViewModel;
  late MyAppointmentsViewModel myAppointmentsViewModel;
  late PayfortViewModel payfortViewModel;
  late PayTabsViewModel paytabsViewModel;
  late AppState appState;

  MyInAppBrowser? browser;
  String selectedPaymentMethod = "";

  String transID = "";

  bool isShowTamara = false;
  String tamaraPaymentStatus = "";
  String tamaraOrderID = "";

  @override
  void initState() {
    scheduleMicrotask(() {
      payfortViewModel.initPayfortViewModel();
      payfortViewModel.setIsApplePayConfigurationLoading(false);
      // myAppointmentsViewModel.getPatientShareAppointment(
      //     widget.patientAppointmentHistoryResponseModel.projectID,
      //     widget.patientAppointmentHistoryResponseModel.clinicID,
      //     widget.patientAppointmentHistoryResponseModel.appointmentNo.toString(), widget.patientAppointmentHistoryResponseModel.isLiveCareAppointment ?? false, onSuccess: (val) {
      //   myAppointmentsViewModel.getTamaraInstallmentsDetails().then((val) {
      //     if (myAppointmentsViewModel.patientAppointmentShareResponseModel!.patientShareWithTax! >= myAppointmentsViewModel.getTamaraInstallmentsDetailsResponseModel!.minLimit!.amount! &&
      //         myAppointmentsViewModel.patientAppointmentShareResponseModel!.patientShareWithTax! <= myAppointmentsViewModel.getTamaraInstallmentsDetailsResponseModel!.maxLimit!.amount!) {
      //       setState(() {
      //         isShowTamara = true;
      //       });
      //     }
      //   });
      // }, onError: (err) {
      //   Navigator.of(context).pop();
      //   Navigator.of(context).pop();
      // });
    });
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    appState = getIt.get<AppState>();
    bookAppointmentsViewModel = Provider.of<BookAppointmentsViewModel>(context);
    myAppointmentsViewModel = Provider.of<MyAppointmentsViewModel>(context);
    payfortViewModel = Provider.of<PayfortViewModel>(context);
    paytabsViewModel = Provider.of<PayTabsViewModel>(context, listen: false);
    return Scaffold(
      backgroundColor: AppColors.bgScaffoldColor,
      body: Consumer<BookAppointmentsViewModel>(builder: (context, bookAppointmentsVM, child) {
        return Column(
          children: [
            Expanded(
              child: CollapsingListView(
                title: LocaleKeys.appointmentPayment.tr(context: context),
                child: SingleChildScrollView(
                  child: Column(
                    crossAxisAlignment: CrossAxisAlignment.start,
                    children: [
                      SizedBox(height: 24.h),
                      Container(
                        decoration: RoundedRectangleBorder().toSmoothCornerDecoration(
                          color: AppColors.whiteColor,
                          borderRadius: 20.h,
                          hasShadow: false,
                        ),
                        child: Row(
                          mainAxisSize: MainAxisSize.max,
                          children: [
                            Column(
                              crossAxisAlignment: CrossAxisAlignment.start,
                              children: [
                                Utils.buildImgWithAssets(icon: AppAssets.mada, width: 72.h, height: 25.h, fit: BoxFit.contain),
                                SizedBox(height: 16.h),
                                LocaleKeys.mada.tr(context: context).toText16(isBold: true),
                              ],
                            ),
                            SizedBox(width: 8.h),
                            const Spacer(),
                            Transform.flip(
                              flipX: appState.isArabic(),
                              child: Utils.buildSvgWithAssets(
                                icon: AppAssets.forward_arrow_icon_small,
                                iconColor: AppColors.blackColor,
                                width: 18.h,
                                height: 13.h,
                                fit: BoxFit.contain,
                              ),
                            ),
                          ],
                        ).paddingSymmetrical(16.h, 16.h),
                      ).paddingSymmetrical(24.h, 0.h).onPress(() async {
                        selectedPaymentMethod = "MADA";
                        if (appState.isPaytabsEnabled) {
                          transID = Utils.getAppointmentTransID(
                            bookAppointmentsViewModel.selectedDoctor.projectID!,
                            bookAppointmentsViewModel.selectedDoctor.clinicID!,
                            bookAppointmentsViewModel.selectedDoctor.doctorID!,
                          );
                          paytabsViewModel.setPaymentConfiguration(
                            "Appointment Payment",
                            bookAppointmentsViewModel.patientWalkInAppointmentShareResponseModel!.patientShareWithTax!,
                          );
                          paytabsViewModel.startCardPayment(
                              paymentOption: selectedPaymentMethod,
                              liveServiceID: "0",
                              isScheduleLiveCare: "false",
                              appointmentDate: DateUtil.convertDateToString(DateTime.now()),
                              appointmentNo: DateTime.now().millisecondsSinceEpoch.toString(),
                              doctorID: bookAppointmentsViewModel.selectedDoctor.doctorID.toString(),
                              transactionID: transID,
                              amount: myAppointmentsViewModel.patientAppointmentShareResponseModel!.patientShareWithTax!.toString(),
                              fileNumber: appState.getAuthenticatedUser()!.patientId.toString(),
                              orderDescription: "Appointment Payment",
                              serviceID: ServiceTypeEnum.appointmentPayment.getIdFromServiceEnum().toString(),
                              projectID: bookAppointmentsViewModel.selectedDoctor.projectID.toString(),
                              onSuccess: (PaytabsTransactionResponseModel transactionData) async {
                                LoaderBottomSheet.showLoader(loadingText: LocaleKeys.bookingWaitingAppointment.tr(context: context));
                            await bookAppointmentsViewModel.insertSpecificAppointmentForWalkIn(onSuccess: (val) async {
                              String appointmentNo = val.data['AppointmentNo'].toString();
                              await myAppointmentsViewModel.createAdvancePayment(
                                  paymentMethodName: selectedPaymentMethod,
                                  projectID: bookAppointmentsViewModel.waitingAppointmentProjectID,
                                  clinicID: bookAppointmentsViewModel.selectedDoctor.clinicID!,
                                  appointmentNo: appointmentNo,
                                  payedAmount: bookAppointmentsViewModel.patientWalkInAppointmentShareResponseModel!.patientShareWithTax!,
                                  paymentReference: transactionData.transactionReference!,
                                  patientID: appState.getAuthenticatedUser()!.patientId.toString(),
                                  patientType: appState.getAuthenticatedUser()!.patientType!,
                                  onSuccess: (value) async {
                                    print(value);
                                    await myAppointmentsViewModel.addAdvanceNumberRequest(
                                        advanceNumber: Utils.isVidaPlusProject(bookAppointmentsViewModel.waitingAppointmentProjectID)
                                            ? value.data['OnlineCheckInAppointments'][0]['AdvanceNumber_VP'].toString()
                                            : value.data['OnlineCheckInAppointments'][0]['AdvanceNumber'].toString(),
                                        paymentReference: transactionData.transactionReference!,
                                        appointmentNo: appointmentNo,
                                        onSuccess: (value) async {
                                          LoaderBottomSheet.hideLoader();
                                          sendCheckInRequest(bookAppointmentsViewModel.waitingAppointmentNFCCode, appointmentNo, context);
                                        });
                                  });
                            });
                          }, onError: (err) {
                            showCommonBottomSheetWithoutHeight(
                              context,
                              child: Utils.getErrorWidget(loadingText: err.toString()),
                              callBackFunc: () {},
                              isFullScreen: false,
                              isCloseButtonVisible: true,
                            );
                          });
                        } else {
                          if (appState.isPayfortHostedPageEnabled) {
                            LoaderBottomSheet.showLoader(loadingText: LocaleKeys.fetchingPaymentInformation.tr(context: context));

                            transID = Utils.getAppointmentTransID(
                              bookAppointmentsViewModel.selectedDoctor.projectID!,
                              bookAppointmentsViewModel.selectedDoctor.clinicID!,
                              bookAppointmentsViewModel.selectedDoctor.doctorID!,
                            );

                            await payfortViewModel.getPayfortConfigurations(
                                serviceId: ServiceTypeEnum.appointmentPayment.getIdFromServiceEnum(), projectId: bookAppointmentsViewModel.selectedDoctor.projectID!, integrationId: 1);

                            payfortViewModel.initiatePaymentWithCard(
                              "mada",
                              "0",
                              "false",
                              DateUtil.convertDateToString(DateTime.now()),
                              DateTime.now().millisecondsSinceEpoch.toString(),
                              bookAppointmentsViewModel.selectedDoctor.doctorID.toString(),
                              transactionID: transID,
                              fileNumber: appState.getAuthenticatedUser()!.patientId.toString(),
                              amount: bookAppointmentsViewModel.patientWalkInAppointmentShareResponseModel!.patientShareWithTax!.toString(),
                              orderDescription: "Appointment Payment",
                              onSucceeded: (paymentResult) async {
                                print("Payment Success Data: ${paymentResult.toString()}");
                                LoaderBottomSheet.hideLoader();
                                LoaderBottomSheet.showLoader(loadingText: LocaleKeys.bookingWaitingAppointment.tr(context: context));
                                await bookAppointmentsViewModel.insertSpecificAppointmentForWalkIn(onSuccess: (val) async {
                                  String appointmentNo = val.data['AppointmentNo'].toString();
                                  await myAppointmentsViewModel.createAdvancePayment(
                                      paymentMethodName: selectedPaymentMethod,
                                      projectID: bookAppointmentsViewModel.waitingAppointmentProjectID,
                                      clinicID: bookAppointmentsViewModel.selectedDoctor.clinicID!,
                                      appointmentNo: appointmentNo,
                                      payedAmount: payfortViewModel.payfortCheckPaymentStatusResponseModel!.amount!,
                                      paymentReference: payfortViewModel.payfortCheckPaymentStatusResponseModel!.fortId!,
                                      patientID: appState.getAuthenticatedUser()!.patientId.toString(),
                                      patientType: appState.getAuthenticatedUser()!.patientType!,
                                      onSuccess: (value) async {
                                        print(value);
                                        await myAppointmentsViewModel.addAdvanceNumberRequest(
                                            advanceNumber: Utils.isVidaPlusProject(bookAppointmentsViewModel.waitingAppointmentProjectID)
                                                ? value.data['OnlineCheckInAppointments'][0]['AdvanceNumber_VP'].toString()
                                                : value.data['OnlineCheckInAppointments'][0]['AdvanceNumber'].toString(),
                                            paymentReference: payfortViewModel.payfortCheckPaymentStatusResponseModel!.fortId!,
                                            appointmentNo: appointmentNo,
                                            onSuccess: (value) async {
                                              LoaderBottomSheet.hideLoader();
                                              sendCheckInRequest(bookAppointmentsViewModel.waitingAppointmentNFCCode, appointmentNo, context);
                                            });
                                      });
                                });
                              },
                              onFailed: (err) {
                                print("Payment Failed Data: ${err.toString()}");
                                showCommonBottomSheetWithoutHeight(
                                  context,
                                  child: Utils.getErrorWidget(loadingText: LocaleKeys.paymentFailedPleaseTryAgain.tr(context: context)),
                                  callBackFunc: () {},
                                  isFullScreen: false,
                                  isCloseButtonVisible: true,
                                );
                              },
                            );
                          } else {
                            openPaymentURL("mada");
                          }
                        }
                      }),
                      SizedBox(height: 16.h),
                      Container(
                        decoration: RoundedRectangleBorder().toSmoothCornerDecoration(
                          color: AppColors.whiteColor,
                          borderRadius: 20.h,
                          hasShadow: false,
                        ),
                        child: Row(
                          mainAxisSize: MainAxisSize.max,
                          children: [
                            Column(
                              crossAxisAlignment: CrossAxisAlignment.start,
                              children: [
                                Row(
                                  children: [
                                    Utils.buildImgWithAssets(icon: AppAssets.visa, width: 50.h, height: 50.h),
                                    SizedBox(width: 8.h),
                                    Utils.buildImgWithAssets(icon: AppAssets.mastercard, width: 40.h, height: 40.h, fit: BoxFit.contain),
                                  ],
                                ),
                                SizedBox(height: 16.h),
                                LocaleKeys.visaOrMastercard.tr(context: context).toText16(isBold: true),
                              ],
                            ),
                            SizedBox(width: 8.h),
                            const Spacer(),
                            Transform.flip(
                              flipX: appState.isArabic(),
                              child: Utils.buildSvgWithAssets(
                                icon: AppAssets.forward_arrow_icon_small,
                                iconColor: AppColors.blackColor,
                                width: 18.h,
                                height: 13.h,
                                fit: BoxFit.contain,
                              ),
                            ),
                          ],
                        ).paddingSymmetrical(16.h, 16.h),
                      ).paddingSymmetrical(24.h, 0.h).onPress(() async {
                        selectedPaymentMethod = "VISA";
                        if (appState.isPaytabsEnabled) {
                          transID = Utils.getAppointmentTransID(
                            bookAppointmentsViewModel.selectedDoctor.projectID!,
                            bookAppointmentsViewModel.selectedDoctor.clinicID!,
                            bookAppointmentsViewModel.selectedDoctor.doctorID!,
                          );

                          paytabsViewModel.setPaymentConfiguration(
                            "Appointment Payment",
                            bookAppointmentsViewModel.patientWalkInAppointmentShareResponseModel!.patientShareWithTax!,
                          );
                          paytabsViewModel.startCardPayment(
                              paymentOption: selectedPaymentMethod,
                              liveServiceID: "0",
                              isScheduleLiveCare: "false",
                              appointmentDate: DateUtil.convertDateToString(DateTime.now()),
                              appointmentNo: DateTime.now().millisecondsSinceEpoch.toString(),
                              doctorID: bookAppointmentsViewModel.selectedDoctor.doctorID.toString(),
                              transactionID: transID,
                              amount: myAppointmentsViewModel.patientAppointmentShareResponseModel!.patientShareWithTax!.toString(),
                              fileNumber: appState.getAuthenticatedUser()!.patientId.toString(),
                              orderDescription: "Appointment Payment",
                              serviceID: ServiceTypeEnum.appointmentPayment.getIdFromServiceEnum().toString(),
                              projectID: bookAppointmentsViewModel.selectedDoctor.projectID.toString(),
                              onSuccess: (PaytabsTransactionResponseModel transactionData) async {
                                LoaderBottomSheet.showLoader(loadingText: LocaleKeys.bookingWaitingAppointment.tr(context: context));
                            await bookAppointmentsViewModel.insertSpecificAppointmentForWalkIn(onSuccess: (val) async {
                              String appointmentNo = val.data['AppointmentNo'].toString();
                              await myAppointmentsViewModel.createAdvancePayment(
                                  paymentMethodName: selectedPaymentMethod,
                                  projectID: bookAppointmentsViewModel.waitingAppointmentProjectID,
                                  clinicID: bookAppointmentsViewModel.selectedDoctor.clinicID!,
                                  appointmentNo: appointmentNo,
                                  payedAmount: bookAppointmentsViewModel.patientWalkInAppointmentShareResponseModel!.patientShareWithTax!,
                                  paymentReference: transactionData.transactionReference!,
                                  patientID: appState.getAuthenticatedUser()!.patientId.toString(),
                                  patientType: appState.getAuthenticatedUser()!.patientType!,
                                  onSuccess: (value) async {
                                    print(value);
                                    await myAppointmentsViewModel.addAdvanceNumberRequest(
                                        advanceNumber: Utils.isVidaPlusProject(bookAppointmentsViewModel.waitingAppointmentProjectID)
                                            ? value.data['OnlineCheckInAppointments'][0]['AdvanceNumber_VP'].toString()
                                            : value.data['OnlineCheckInAppointments'][0]['AdvanceNumber'].toString(),
                                        paymentReference: transactionData.transactionReference!,
                                        appointmentNo: appointmentNo,
                                        onSuccess: (value) async {
                                          LoaderBottomSheet.hideLoader();
                                          sendCheckInRequest(bookAppointmentsViewModel.waitingAppointmentNFCCode, appointmentNo, context);
                                        });
                                  });
                            });
                          }, onError: (err) {
                            showCommonBottomSheetWithoutHeight(
                              context,
                              child: Utils.getErrorWidget(loadingText: err.toString()),
                              callBackFunc: () {},
                              isFullScreen: false,
                              isCloseButtonVisible: true,
                            );
                          });
                        } else {
                          if (appState.isPayfortHostedPageEnabled) {
                            LoaderBottomSheet.showLoader(loadingText: LocaleKeys.fetchingPaymentInformation.tr(context: context));

                            transID = Utils.getAppointmentTransID(
                              bookAppointmentsViewModel.selectedDoctor.projectID!,
                              bookAppointmentsViewModel.selectedDoctor.clinicID!,
                              bookAppointmentsViewModel.selectedDoctor.doctorID!,
                            );

                            await payfortViewModel.getPayfortConfigurations(
                                serviceId: ServiceTypeEnum.appointmentPayment.getIdFromServiceEnum(), projectId: bookAppointmentsViewModel.selectedDoctor.projectID!, integrationId: 1);

                            payfortViewModel.initiatePaymentWithCard(
                              "visa",
                              "0",
                              "false",
                              DateUtil.convertDateToString(DateTime.now()),
                              DateTime.now().millisecondsSinceEpoch.toString(),
                              bookAppointmentsViewModel.selectedDoctor.doctorID.toString(),
                              transactionID: transID,
                              fileNumber: appState.getAuthenticatedUser()!.patientId.toString(),
                              amount: bookAppointmentsViewModel.patientWalkInAppointmentShareResponseModel!.patientShareWithTax!.toString(),
                              orderDescription: "Appointment Payment",
                              onSucceeded: (paymentResult) async {
                                print("Payment Success Data: ${paymentResult.toString()}");
                                LoaderBottomSheet.hideLoader();
                                LoaderBottomSheet.showLoader(loadingText: LocaleKeys.bookingWaitingAppointment.tr(context: context));
                                await bookAppointmentsViewModel.insertSpecificAppointmentForWalkIn(onSuccess: (val) async {
                                  String appointmentNo = val.data['AppointmentNo'].toString();
                                  await myAppointmentsViewModel.createAdvancePayment(
                                      paymentMethodName: selectedPaymentMethod,
                                      projectID: bookAppointmentsViewModel.waitingAppointmentProjectID,
                                      clinicID: bookAppointmentsViewModel.selectedDoctor.clinicID!,
                                      appointmentNo: appointmentNo,
                                      payedAmount: payfortViewModel.payfortCheckPaymentStatusResponseModel!.amount!,
                                      paymentReference: payfortViewModel.payfortCheckPaymentStatusResponseModel!.fortId!,
                                      patientID: appState.getAuthenticatedUser()!.patientId.toString(),
                                      patientType: appState.getAuthenticatedUser()!.patientType!,
                                      onSuccess: (value) async {
                                        print(value);
                                        await myAppointmentsViewModel.addAdvanceNumberRequest(
                                            advanceNumber: Utils.isVidaPlusProject(bookAppointmentsViewModel.waitingAppointmentProjectID)
                                                ? value.data['OnlineCheckInAppointments'][0]['AdvanceNumber_VP'].toString()
                                                : value.data['OnlineCheckInAppointments'][0]['AdvanceNumber'].toString(),
                                            paymentReference: payfortViewModel.payfortCheckPaymentStatusResponseModel!.fortId!,
                                            appointmentNo: appointmentNo,
                                            onSuccess: (value) async {
                                              LoaderBottomSheet.hideLoader();
                                              sendCheckInRequest(bookAppointmentsViewModel.waitingAppointmentNFCCode, appointmentNo, context);
                                            });
                                      });
                                });
                              },
                              onFailed: (err) {
                                print("Payment Failed Data: ${err.toString()}");
                                showCommonBottomSheetWithoutHeight(
                                  context,
                                  child: Utils.getErrorWidget(loadingText: LocaleKeys.paymentFailedPleaseTryAgain.tr(context: context)),
                                  callBackFunc: () {},
                                  isFullScreen: false,
                                  isCloseButtonVisible: true,
                                );
                              },
                            );
                          } else {
                            openPaymentURL("visa");
                          }
                        }
                      }),
                      SizedBox(height: 16.h),
                      isShowTamara
                          ? Container(
                              decoration: RoundedRectangleBorder().toSmoothCornerDecoration(
                                color: AppColors.whiteColor,
                                borderRadius: 20.h,
                                hasShadow: false,
                              ),
                              child: Row(
                                mainAxisSize: MainAxisSize.max,
                                children: [
                                  Column(
                                    crossAxisAlignment: CrossAxisAlignment.start,
                                    children: [
                                      Utils.buildImgWithAssets(icon: AppAssets.tamaraEng, width: 72.h, height: 25.h),
                                      SizedBox(height: 16.h),
                                      LocaleKeys.tamara.tr(context: context).toText16(isBold: true),
                                    ],
                                  ),
                                  SizedBox(width: 8.h),
                                  const Spacer(),
                                  Transform.flip(
                                    flipX: appState.isArabic(),
                                    child: Utils.buildSvgWithAssets(
                                      icon: AppAssets.forward_arrow_icon_small,
                                      iconColor: AppColors.blackColor,
                                      width: 18.h,
                                      height: 13.h,
                                      fit: BoxFit.contain,
                                    ),
                                  ),
                                ],
                              ).paddingSymmetrical(16.h, 16.h),
                            ).paddingSymmetrical(24.h, 0.h).onPress(() {
                              selectedPaymentMethod = "TAMARA";
                              openPaymentURL("tamara");
                            })
                          : SizedBox.shrink(),
                    ],
                  ),
                ),
              ),
            ),
            Container(
              decoration: RoundedRectangleBorder().toSmoothCornerDecoration(
                color: AppColors.whiteColor,
                borderRadius: 24.h,
                hasShadow: false,
              ),
              child: Consumer<PayfortViewModel>(builder: (context, payfortVM, child) {
                //TODO: Need to add loading state & animation for Apple Pay Configuration
                return Column(
                  crossAxisAlignment: CrossAxisAlignment.start,
                  children: [
                    (bookAppointmentsVM.patientWalkInAppointmentShareResponseModel!.isCash ?? true)
                        ? Container(
                            height: 50.h,
                            decoration: ShapeDecoration(
                              color: AppColors.secondaryLightRedBorderColor,
                              shape: SmoothRectangleBorder(
                                borderRadius: BorderRadius.only(topLeft: Radius.circular(24), topRight: Radius.circular(24)),
                                smoothness: 1,
                              ),
                            ),
                            child: Row(
                              mainAxisAlignment: MainAxisAlignment.spaceBetween,
                              children: [
                                LocaleKeys.insuranceExpiredOrInactive.tr(context: context).toText14(color: AppColors.primaryRedColor, isBold: true)
                                    .paddingSymmetrical(24.h, 0.h),
                                CustomButton(
                                  text: LocaleKeys.updateInsurance.tr(context: context),
                                  onPressed: () {
                                    Navigator.of(context).push(
                                      CustomPageRoute(
                                        page: InsuranceHomePage(),
                                      ),
                                    );
                                  },
                                  backgroundColor: AppColors.primaryRedColor,
                                  borderColor: AppColors.secondaryLightRedBorderColor,
                                  textColor: AppColors.whiteColor,
                                  fontSize: 10.f,
                                  fontWeight: FontWeight.w600,
                                  borderRadius: 8,
                                  padding: EdgeInsets.fromLTRB(15, 0, 15, 0),
                                  height: 30.h,
                                ).paddingSymmetrical(24.h, 0.h),
                              ],
                            ),
                          )
                        : const SizedBox(),
                    SizedBox(height: 24.h),
                    LocaleKeys.totalAmountToPay.tr(context: context).toText18(isBold: true).paddingSymmetrical(24.h, 0.h),
                    SizedBox(height: 17.h),
                    Row(
                      mainAxisAlignment: MainAxisAlignment.spaceBetween,
                      children: [
                        LocaleKeys.amountBeforeTax.tr(context: context).toText14(isBold: true),
                        Utils.getPaymentAmountWithSymbol(
                            bookAppointmentsVM.patientWalkInAppointmentShareResponseModel!.patientShare!.toString().toText16(isBold: true),
                            AppColors.blackColor,
                            13,
                            isSaudiCurrency: true),
                      ],
                    ).paddingSymmetrical(24.h, 0.h),
                    Row(
                      mainAxisAlignment: MainAxisAlignment.spaceBetween,
                      children: [
                        LocaleKeys.vat15.tr(context: context).toText14(isBold: true, color: AppColors.greyTextColor),
                        Utils.getPaymentAmountWithSymbol(
                            bookAppointmentsVM.patientWalkInAppointmentShareResponseModel!.patientTaxAmount!
                                .toString()
                                .toText14(isBold: true, color: AppColors.greyTextColor),
                            AppColors.greyTextColor,
                            13,
                            isSaudiCurrency: true),
                      ],
                    ).paddingSymmetrical(24.h, 0.h),
                    SizedBox(height: 17.h),
                    Row(
                      mainAxisAlignment: MainAxisAlignment.spaceBetween,
                      children: [
                        "".toText14(isBold: true),
                        Utils.getPaymentAmountWithSymbol(
                            bookAppointmentsVM.patientWalkInAppointmentShareResponseModel!.patientShareWithTax!.toString().toText24(isBold: true),
                            AppColors.blackColor,
                            17,
                            isSaudiCurrency: true),
                      ],
                    ).paddingSymmetrical(24.h, 0.h),
                    Platform.isIOS
                        ? Utils.buildSvgWithAssets(
                            icon: AppAssets.apple_pay_button,
                            width: 200.h,
                            height: 80.h,
                            fit: BoxFit.contain,
                      applyThemeColor: false
                          ).paddingSymmetrical(24.h, 0.h).onPress(() {
                            // payfortVM.setIsApplePayConfigurationLoading(true);
                            if (Utils.havePrivilege(103)) {
                              startApplePay();
                            } else {
                              openPaymentURL("ApplePay");
                            }
                          })
                        : SizedBox(height: 12.h),
                    SizedBox(height: 12.h),
                  ],
                );
              }),
            ),
          ],
        );
      }),
    );
  }

  onBrowserLoadStart(String url) {
    print("onBrowserLoadStart");
    print(url);

    if (selectedPaymentMethod == "tamara") {
      if (Platform.isAndroid) {
        Uri uri = new Uri.dataFromString(url);
        tamaraPaymentStatus = uri.queryParameters['status']!;
        tamaraOrderID = uri.queryParameters['AuthorizePaymentId']!;
      } else {
        Uri uri = new Uri.dataFromString(url);
        tamaraPaymentStatus = uri.queryParameters['paymentStatus']!;
        tamaraOrderID = uri.queryParameters['orderId']!;
      }
    }

    // if(selectedPaymentMethod != "TAMARA") {
    MyInAppBrowser.successURLS.forEach((element) {
      if (url.contains(element)) {
        browser?.close();
        MyInAppBrowser.isPaymentDone = true;
        return;
      }
    });
    // }

    // if(selectedPaymentMethod != "TAMARA") {
    MyInAppBrowser.errorURLS.forEach((element) {
      if (url.contains(element)) {
        browser?.close();
        MyInAppBrowser.isPaymentDone = false;
        return;
      }
    });
    // }
  }

  onBrowserExit(bool isPaymentMade) async {
    checkPaymentStatus();
  }

  void checkPaymentStatus() async {
    LoaderBottomSheet.showLoader(loadingText: LocaleKeys.checkingPaymentStatusPleaseWait.tr(context: context));
    if (selectedPaymentMethod == "TAMARA") {
      await payfortViewModel.checkTamaraPaymentStatus(
          transactionID: transID,
          onSuccess: (apiResponse) async {
            if (apiResponse.data["status"].toString().toLowerCase() == "success") {
              tamaraOrderID = apiResponse.data["tamara_order_id"].toString();
              await payfortViewModel.updateTamaraRequestStatus(
                  responseMessage: "success", status: "14", clientRequestID: transID, tamaraOrderID: tamaraOrderID);
              await payfortViewModel.markAppointmentAsTamaraPaid(
                  projectID: bookAppointmentsViewModel.selectedDoctor.projectID!, appointmentNo: DateTime.now().millisecondsSinceEpoch);
              // await myAppointmentsViewModel.addAdvanceNumberRequest(
              //     advanceNumber: "Tamara-Advance-0000",
              //     paymentReference: tamaraOrderID,
              //     appointmentNo: widget.patientAppointmentHistoryResponseModel.appointmentNo.toString(),
              //     onSuccess: (value) async {
              //       if (widget.patientAppointmentHistoryResponseModel.isLiveCareAppointment!) {
              //         //TODO: Implement LiveCare Check-In API Call
              //         await myAppointmentsViewModel.insertLiveCareVIDARequest(
              //             clientRequestID: tamaraOrderID,
              //             patientAppointmentHistoryResponseModel: widget.patientAppointmentHistoryResponseModel,
              //             onSuccess: (apiResponse) {
              //               Future.delayed(Duration(milliseconds: 500), () {
              //                 LoaderBottomSheet.hideLoader();
              //                 Navigator.pushAndRemoveUntil(
              //                     context,
              //                     CustomPageRoute(
              //                       page: LandingNavigation(),
              //                     ),
              //                         (r) => false);
              //               });
              //             },
              //             onError: (error) {});
              //       } else {
              //         await myAppointmentsViewModel.generateAppointmentQR(
              //             clinicID: widget.patientAppointmentHistoryResponseModel.clinicID,
              //             projectID: widget.patientAppointmentHistoryResponseModel.projectID,
              //             appointmentNo: widget.patientAppointmentHistoryResponseModel.appointmentNo.toString(),
              //             isFollowUp: myAppointmentsViewModel.patientAppointmentShareResponseModel!.isFollowup!,
              //             onSuccess: (apiResponse) {
              //               Future.delayed(Duration(milliseconds: 500), () {
              //                 LoaderBottomSheet.hideLoader();
              //                 Navigator.pushAndRemoveUntil(
              //                     context,
              //                     CustomPageRoute(
              //                       page: LandingNavigation(),
              //                     ),
              //                         (r) => false);
              //               });
              //             });
              //       }
              //     });
            } else {
              await payfortViewModel.updateTamaraRequestStatus(
                  responseMessage: "Failed", status: "00", clientRequestID: transID, tamaraOrderID: tamaraOrderID);
              LoaderBottomSheet.hideLoader();
              showCommonBottomSheetWithoutHeight(
                context,
                child: Utils.getErrorWidget(loadingText: LocaleKeys.paymentFailedPleaseTryAgain.tr(context: context)),
                callBackFunc: () {},
                isFullScreen: false,
                isCloseButtonVisible: true,
              );
            }
          },
          onError: (err) {
            LoaderBottomSheet.hideLoader();
            showCommonBottomSheetWithoutHeight(
              context,
              child: Utils.getErrorWidget(loadingText: err),
              callBackFunc: () {},
              isFullScreen: false,
              isCloseButtonVisible: true,
            );
          });
    } else {
      await payfortViewModel.checkPaymentStatus(
          transactionID: transID,
          onSuccess: (apiResponse) async {
            print(apiResponse.data);
            if (payfortViewModel.payfortCheckPaymentStatusResponseModel!.responseMessage!.toLowerCase() == "success") {
              LoaderBottomSheet.hideLoader();
              LoaderBottomSheet.showLoader(loadingText: LocaleKeys.bookingWaitingAppointment.tr(context: context));
              await bookAppointmentsViewModel.insertSpecificAppointmentForWalkIn(onSuccess: (val) async {
                String appointmentNo = val.data['AppointmentNo'].toString();
                await myAppointmentsViewModel.createAdvancePayment(
                    paymentMethodName: selectedPaymentMethod,
                    projectID: bookAppointmentsViewModel.waitingAppointmentProjectID,
                    clinicID: bookAppointmentsViewModel.selectedDoctor.clinicID!,
                    appointmentNo: appointmentNo,
                    payedAmount: payfortViewModel.payfortCheckPaymentStatusResponseModel!.amount!,
                    paymentReference: payfortViewModel.payfortCheckPaymentStatusResponseModel!.fortId!,
                    patientID: appState.getAuthenticatedUser()!.patientId.toString(),
                    patientType: appState.getAuthenticatedUser()!.patientType!,
                    onSuccess: (value) async {
                      print(value);
                      await myAppointmentsViewModel.addAdvanceNumberRequest(
                          advanceNumber: Utils.isVidaPlusProject(bookAppointmentsViewModel.waitingAppointmentProjectID)
                              ? value.data['OnlineCheckInAppointments'][0]['AdvanceNumber_VP'].toString()
                              : value.data['OnlineCheckInAppointments'][0]['AdvanceNumber'].toString(),
                          paymentReference: payfortViewModel.payfortCheckPaymentStatusResponseModel!.fortId!,
                          appointmentNo: appointmentNo,
                          onSuccess: (value) async {
                            LoaderBottomSheet.hideLoader();
                            sendCheckInRequest(bookAppointmentsViewModel.waitingAppointmentNFCCode, appointmentNo, context);
                          });
                    });
              });
            } else {
              LoaderBottomSheet.hideLoader();
              showCommonBottomSheetWithoutHeight(
                context,
                child: Utils.getErrorWidget(loadingText: LocaleKeys.paymentFailedPleaseTryAgain.tr(context: context)),
                callBackFunc: () {},
                isFullScreen: false,
                isCloseButtonVisible: true,
              );
            }
          });
    }
  }

  openPaymentURL(String paymentMethod) {
    browser = MyInAppBrowser(onExitCallback: onBrowserExit, onLoadStartCallback: onBrowserLoadStart, context: context);
    transID = Utils.getAppointmentTransID(
      bookAppointmentsViewModel.selectedDoctor.projectID!,
      bookAppointmentsViewModel.selectedDoctor.clinicID!,
      bookAppointmentsViewModel.selectedDoctor.doctorID!,
    );

    //TODO: Need to pass dynamic params to the payment request instead of static values
    browser?.openPaymentBrowser(
        bookAppointmentsViewModel.patientWalkInAppointmentShareResponseModel!.patientShareWithTax!,
        "Appointment check in",
        transID,
        bookAppointmentsViewModel.selectedDoctor.projectID.toString(),
        "CustID_${appState.getAuthenticatedUser()!.patientId.toString()}@HMG.com",
        selectedPaymentMethod,
        appState.getAuthenticatedUser()!.patientType.toString(),
        "${appState.getAuthenticatedUser()!.firstName} ${appState.getAuthenticatedUser()!.lastName}",
        appState.getAuthenticatedUser()!.patientId.toString(),
        appState.getAuthenticatedUser()!,
        browser!,
        false,
        "2",
        "",
        context,
        "",
        "",
        "",
        "",
        "3");
  }

  startApplePay() async {
    LoaderBottomSheet.showLoader(loadingText: LocaleKeys.loadingText.tr(context: context));
    transID = Utils.getAppointmentTransID(
      bookAppointmentsViewModel.selectedDoctor.projectID!,
      bookAppointmentsViewModel.selectedDoctor.clinicID!,
      bookAppointmentsViewModel.selectedDoctor.doctorID!,
    );

    ApplePayInsertRequest applePayInsertRequest = ApplePayInsertRequest();

    await payfortViewModel.getPayfortConfigurations(
        serviceId: ServiceTypeEnum.appointmentPayment.getIdFromServiceEnum(),
        projectId: bookAppointmentsViewModel.selectedDoctor.projectID!,
        integrationId: 2);

    applePayInsertRequest.clientRequestID = transID;
    applePayInsertRequest.clinicID = bookAppointmentsViewModel.selectedDoctor.clinicID!;

    applePayInsertRequest.currency = appState.getAuthenticatedUser()!.outSa! == 0 ? "SAR" : "AED";
    applePayInsertRequest.customerEmail = "CustID_${appState.getAuthenticatedUser()!.patientId.toString()}@HMG.com";
    applePayInsertRequest.customerID = appState.getAuthenticatedUser()!.patientId.toString();
    applePayInsertRequest.customerName = "${appState.getAuthenticatedUser()!.firstName} ${appState.getAuthenticatedUser()!.lastName}";

    applePayInsertRequest.deviceToken = await Utils.getStringFromPrefs(CacheConst.pushToken);
    applePayInsertRequest.voipToken = await Utils.getStringFromPrefs(CacheConst.voipToken);
    applePayInsertRequest.doctorID = bookAppointmentsViewModel.selectedDoctor.doctorID;
    applePayInsertRequest.projectID = bookAppointmentsViewModel.selectedDoctor.projectID.toString();
    applePayInsertRequest.serviceID = ServiceTypeEnum.appointmentPayment.getIdFromServiceEnum().toString();
    applePayInsertRequest.channelID = 3;
    applePayInsertRequest.patientID = appState.getAuthenticatedUser()!.patientId.toString();
    applePayInsertRequest.patientTypeID = appState.getAuthenticatedUser()!.patientType;
    applePayInsertRequest.patientOutSA = appState.getAuthenticatedUser()!.outSa;
    applePayInsertRequest.appointmentDate = DateUtil.convertDateToString(DateTime.now());
    applePayInsertRequest.appointmentNo = DateTime.now().millisecondsSinceEpoch;
    applePayInsertRequest.orderDescription = "Appointment Payment";
    applePayInsertRequest.liveServiceID = "0";
    applePayInsertRequest.latitude = "0.0";
    applePayInsertRequest.longitude = "0.0";
    applePayInsertRequest.amount = bookAppointmentsViewModel.patientWalkInAppointmentShareResponseModel!.patientShareWithTax!.toString();
    applePayInsertRequest.isSchedule = "0";
    applePayInsertRequest.language = appState.isArabic() ? 'ar' : 'en';
    applePayInsertRequest.languageID = appState.isArabic() ? 1 : 2;
    applePayInsertRequest.userName = appState.getAuthenticatedUser()!.patientId;
    applePayInsertRequest.responseContinueURL = "http://hmg.com/Documents/success.html";
    applePayInsertRequest.backClickUrl = "http://hmg.com/Documents/success.html";
    applePayInsertRequest.paymentOption = "ApplePay";

    applePayInsertRequest.isMobSDK = true;
    applePayInsertRequest.merchantReference = transID;
    applePayInsertRequest.merchantIdentifier = payfortViewModel.payfortProjectDetailsRespModel!.merchantIdentifier;
    applePayInsertRequest.commandType = "PURCHASE";
    applePayInsertRequest.signature = payfortViewModel.payfortProjectDetailsRespModel!.signature;
    applePayInsertRequest.accessCode = payfortViewModel.payfortProjectDetailsRespModel!.accessCode;
    applePayInsertRequest.shaRequestPhrase = payfortViewModel.payfortProjectDetailsRespModel!.shaRequest;
    applePayInsertRequest.shaResponsePhrase = payfortViewModel.payfortProjectDetailsRespModel!.shaResponse;
    applePayInsertRequest.returnURL = "";

    //TODO: Need to pass dynamic params to the Apple Pay instead of static values
    await payfortViewModel.applePayRequestInsert(applePayInsertRequest: applePayInsertRequest).then((value) {
      if (appState.isPaytabsEnabled) {
        selectedPaymentMethod = "VISA";
        LoaderBottomSheet.hideLoader();
        paytabsViewModel.setPaymentConfiguration(
          "Appointment Payment",
          bookAppointmentsViewModel.patientWalkInAppointmentShareResponseModel!.patientShareWithTax!,
        );
        paytabsViewModel.startApplePayPayment(onSuccess: (PaytabsTransactionResponseModel transactionData) async {
          LoaderBottomSheet.showLoader(loadingText: LocaleKeys.bookingWaitingAppointment.tr(context: context));
          await bookAppointmentsViewModel.insertSpecificAppointmentForWalkIn(onSuccess: (val) async {
            String appointmentNo = val.data['AppointmentNo'].toString();
            await myAppointmentsViewModel.createAdvancePayment(
                paymentMethodName: selectedPaymentMethod,
                projectID: bookAppointmentsViewModel.waitingAppointmentProjectID,
                clinicID: bookAppointmentsViewModel.selectedDoctor.clinicID!,
                appointmentNo: appointmentNo,
                payedAmount: bookAppointmentsViewModel.patientWalkInAppointmentShareResponseModel!.patientShareWithTax!,
                paymentReference: transactionData.transactionReference!,
                patientID: appState.getAuthenticatedUser()!.patientId.toString(),
                patientType: appState.getAuthenticatedUser()!.patientType!,
                onSuccess: (value) async {
                  print(value);
                  await myAppointmentsViewModel.addAdvanceNumberRequest(
                      advanceNumber: Utils.isVidaPlusProject(bookAppointmentsViewModel.waitingAppointmentProjectID)
                          ? value.data['OnlineCheckInAppointments'][0]['AdvanceNumber_VP'].toString()
                          : value.data['OnlineCheckInAppointments'][0]['AdvanceNumber'].toString(),
                      paymentReference: transactionData.transactionReference!,
                      appointmentNo: appointmentNo,
                      onSuccess: (value) async {
                        LoaderBottomSheet.hideLoader();
                        sendCheckInRequest(bookAppointmentsViewModel.waitingAppointmentNFCCode, appointmentNo, context);
                      });
                });
          });
        }, onError: (err) {
          showCommonBottomSheetWithoutHeight(
            context,
            child: Utils.getErrorWidget(loadingText: err.toString()),
            callBackFunc: () {},
            isFullScreen: false,
            isCloseButtonVisible: true,
          );
        });
      } else {
        payfortViewModel.paymentWithApplePay(
          customerName: "${appState.getAuthenticatedUser()!.firstName} ${appState.getAuthenticatedUser()!.lastName}",
          // customerEmail: projectViewModel.authenticatedUserObject.user.emailAddress,
          customerEmail: "CustID_${appState.getAuthenticatedUser()!.patientId.toString()}@HMG.com",
          orderDescription: "Appointment Payment",
          orderAmount: double.parse(bookAppointmentsViewModel.patientWalkInAppointmentShareResponseModel!.patientShareWithTax!.toString()),
          merchantReference: transID,
          merchantIdentifier: payfortViewModel.payfortProjectDetailsRespModel!.merchantIdentifier,
          applePayAccessCode: payfortViewModel.payfortProjectDetailsRespModel!.accessCode,
          applePayShaRequestPhrase: payfortViewModel.payfortProjectDetailsRespModel!.shaRequest,
          currency: appState.getAuthenticatedUser()!.outSa! == 0 ? "SAR" : "AED",
          onFailed: (failureResult) async {
            log("failureResult: ${failureResult.message.toString()}");
            Navigator.of(context).pop();
            showCommonBottomSheetWithoutHeight(
              context,
              child: Utils.getErrorWidget(loadingText: failureResult.message.toString()),
              callBackFunc: () {},
              isFullScreen: false,
              isCloseButtonVisible: true,
            );
          },
          onSucceeded: (successResult) async {
            log("successResult: ${successResult.responseMessage.toString()}");
            selectedPaymentMethod = successResult.paymentOption ?? "VISA";
            checkPaymentStatus();
          },
          // projectId: appo.projectID,
          // serviceTypeEnum: ServiceTypeEnum.appointmentPayment,
        );
      }
    });
  }

  void sendCheckInRequest(String scannedCode, String appointmentNo, BuildContext context) async {
    LoaderBottomSheet.showLoader(loadingText: LocaleKeys.processingCheckIn.tr(context: context));
    PatientAppointmentHistoryResponseModel patientAppointmentHistoryResponseModel = PatientAppointmentHistoryResponseModel(
      appointmentNo: appointmentNo,
      clinicID: bookAppointmentsViewModel.selectedDoctor.clinicID,
      projectID: bookAppointmentsViewModel.selectedDoctor.projectID,
    );
    await myAppointmentsViewModel.sendCheckInNfcRequest(
      patientAppointmentHistoryResponseModel: patientAppointmentHistoryResponseModel,
      scannedCode: scannedCode,
      checkInType: 2,
      onSuccess: (apiResponse) {
        LoaderBottomSheet.hideLoader();
        myAppointmentsViewModel.setIsAppointmentDataToBeLoaded(true);
        myAppointmentsViewModel.getPatientAppointments(true, false);
        showCommonBottomSheetWithoutHeight(context, title: LocaleKeys.success.tr(context: context), child: Utils.getSuccessWidget(loadingText: apiResponse.data["SuccessMsg"]), callBackFunc: () {
          Navigator.of(context).pop();
          Navigator.pushAndRemoveUntil(
              context,
              CustomPageRoute(
                page: LandingNavigation(),
              ),
              (r) => false);
        }, isFullScreen: false);
      },
      onError: (error) {
        LoaderBottomSheet.hideLoader();
        showCommonBottomSheetWithoutHeight(context, title: LocaleKeys.error.tr(context: context), child: Utils.getErrorWidget(loadingText: error), callBackFunc: () {
          Navigator.of(context).pop();
        }, isFullScreen: false);
      },
    );
  }
}
